/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.common;

import java.util.List;

/**
 * UIとの値の受け渡しを担うVOクラスのインターフェース。<br><br>
 * 
 * このインターフェースを実装したVOクラスを、{@link BaseAction}が利用する。<br>
 */
public interface VoInterface {
	
	/**
	 * メッセージを設定する。<br>
	 * @param message
	 */
	public void setMessage(String message);
	
	/**
	 * エラーメッセージを設定する。<br>
	 * @param errMessage エラーメッセージリスト
	 */
	public void setErrMessage(List<String> errMessage);
	
	/**
	 * 処理シーケンスを設定する。<br>
	 * @param procSeq 処理シーケンス
	 */
	public void setProcSeq(String procSeq);
	
	/**
	 * アプリケーションタイトルを取得する。<br>
	 * アプリケーションタイトルはmosp.propertiesで設定する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return アプリケーションタイトル
	 */
	public String getEscTitle();
	
	/**
	 * アプリケーションバージョンを取得する。<br>
	 * アプリケーションバージョンはmosp.propertiesで設定する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return アプリケーションバージョン
	 */
	public String getEscVersion();
	
	/**
	 * アプリケーション著作権表示を取得する。<br>
	 * アプリケーション著作権表示はmosp.propertiesで設定する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return アプリケーション著作権表示
	 */
	public String getEscCopy();
	
	/**
	 * 共通cssファイルURLを取得する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return 共通cssファイル
	 */
	public String getEscCommonCss();
	
	/**
	 * 個別cssファイルURLリストを取得する。<br>
	 * @return 個別cssファイルURL
	 */
	public List<String> getExtraCss();
	
	/**
	 * 個別javascriptファイルURLリストを取得する。<br>
	 * @return 個別javascriptファイルURL
	 */
	public List<String> getExtraJs();
	
	/**
	 * 処理シーケンスを取得する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return 処理シーケンス
	 */
	public String getEscProcSeq();
	
	/**
	 * メッセージを取得する。<br>
	 * 取得文字列はHTMLエスケープされる。<br>
	 * @return メッセージ
	 */
	public String getEscMessage();
	
	/**
	 * エラーメッセージを取得する。<br>
	 * @return エラーメッセージ
	 */
	public List<String> getErrMessage();
	
	/**
	 * エラーメッセージを追加する。<br>
	 * @param errorMessage エラーメッセージ
	 */
	public void addErrMessage(String errorMessage);
	
	/**
	 * エラーフィールドを追加する。<br>
	 * @param errorFieldId エラーフィールド
	 */
	public void addErrField(String errorFieldId);
	
	/**
	 * エラーフィールド(明細)を追加する。<br>
	 * @param rowNo   行番号
	 * @param fieldId エラーフィールド
	 */
	public void addErrDetails(int rowNo, String fieldId);
	
	/**
	 * XMLリターンコード取得。<br>
	 * @return XMLリターンコード
	 */
	public String getXmlRetCode();
	
	/**
	 * javascript取得。<br>
	 * クラスのフィールドの内、public staticで変数名が「PRM_」「NAM_」、
	 * 「REG_」、「LEN_」のものにつき、同一変数名で同一値を宣言する
	 * javascript文字列等を出力する。<br>
	 * @param cls クラス
	 * @return javascript文字列
	 * @throws IllegalAccessException
	 */
	public String getDirectJs(Class<?> cls) throws IllegalAccessException;
	
	/**
	 * javascript取得。<br>
	 * クラスのフィールドの内、publicで変数名が「PRM_」「NAM_」、
	 * 「REG_」、「LEN_」のものにつき、同一変数名で同一値を宣言する
	 * javascript文字列等を出力する。<br>
	 * @param cls クラス
	 * @param obj オブジェクト
	 * @return javascript文字列
	 * @throws IllegalAccessException
	 */
	public String getDirectJs(Class<?> cls, Object obj) throws IllegalAccessException;
	
	/**
	 * ダイアログフラグ取得<br>
	 * @return ダイアログフラグ
	 */
	public boolean getIsDialog();
	
	/**
	 * クラス名取得。<br>
	 * @return クラス名
	 */
	public String getClassName();

}
